# [[file:../../arroyo-native-parser.org::*=arroyo.models.Reference= Table][=arroyo.models.Reference= Table:1]]
from typing import Optional, List

from sqlmodel import SQLModel, Relationship, Field
from sqlmodel import Session

import arroyo.arroyo_rs as native

class Reference(SQLModel, table=True):
  heading_id: Optional[str] = Field(default=None, foreign_key="heading.id")
  ref: Optional[str] = Field(default=None, primary_key=True)

  heading: Optional["Heading"] = Relationship(
    back_populates="references",
    sa_relationship_kwargs={"cascade": "delete"})

  @classmethod
  def from_native_doc(cls, doc: native.Document):
    return [
      cls(heading_id=heading.id, ref=ref)
      for heading in doc.headings or []
      for ref in heading.refs or []
      if heading.id is not None
    ]
# =arroyo.models.Reference= Table:1 ends here
