# [[file:../../arroyo-native-parser.org::*=arroyo.models.Tag= Table][=arroyo.models.Tag= Table:3]]
from typing import Optional, List

from sqlmodel import SQLModel, Relationship, Field
from sqlmodel import Session

import arroyo.arroyo_rs as native

class Tag(SQLModel, table=True):
  heading_id: Optional[str] = Field(default=None, foreign_key="heading.id", primary_key=True)
  tag: Optional[str] = Field(default=None, primary_key=True)

  heading: Optional["Heading"] = Relationship(
    back_populates="tags",
    sa_relationship_kwargs={"cascade": "delete"})

  @classmethod
  def from_native_doc(cls, doc: native.Document):
    return [
      cls(heading_id=heading.id, tag=tag)
      for heading in doc.headings or []
      for tag in heading.tags or []
      if heading.id is not None
    ]
# =arroyo.models.Tag= Table:3 ends here
