# [[file:arroyo-native-parser.org::*Put it all together and make it distributable with a Nix flake][Put it all together and make it distributable with a Nix flake:1]]
{
  description = "Arroyo Parser Exporter Library";

  inputs.flake-utils.url = "github:numtide/flake-utils";

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
          config.allowUnfree = true;
        };

        python3 = pkgs.python3;
      in
        {
          devShells.default = pkgs.callPackage ./shell.nix { inherit python3; };

          packages = rec {
            arroyo_rs = pkgs.callPackage ./default.nix { inherit python3; };
            default = arroyo_rs;
          };

          apps = rec {
            arroyo_rs = flake-utils.lib.mkApp {
              drv = self.packages.${system}.arroyo_rs;
              exePath = "/bin/arroyo";
            };
            default = arroyo_rs;
          };
        }
    );
}
# Put it all together and make it distributable with a Nix flake:1 ends here
