# [[file:arroyo-native-parser.org::*Development Shell][Development Shell:1]]
{ pkgs ? import <nixpkgs> {},
  python3 ? pkgs.python3
}:
let
  myPy = python3.withPackages( pp: with pp; [
    pip
    pytest
  ]);
in pkgs.mkShell {
  packages = with pkgs; [
    cargo
    rustc
    gcc

    rust-analyzer
    rustfmt
    clippy

    maturin
    myPy
    pyright
    black
  ];
  RUST_SRC_PATH = "${pkgs.rust.packages.stable.rustPlatform.rustLibSrc}";
  NIX_CONFIG = "builders =";

  shellHook = ''
    test -f venv/bin/python3 || python3 -m venv venv
    . venv/bin/activate
    maturin develop -j6
  '';
}
# Development Shell:1 ends here
