# [[file:arroyo-native-parser.org::*=sqlmodel= package][=sqlmodel= package:1]]
{
  pkgs ? import <nixpkgs> {},
  lib  ? pkgs.lib,

  python3 ? pkgs.python3,
}:

with python3.pkgs; buildPythonPackage rec {
  pname = "sqlmodel";
  version = "0.0.8";
  format = "pyproject";

  disabled = pythonOlder "3.7";
  # src = pkgs.fetchFromGitHub {
  #   owner = "tiangolo";
  #   repo = "sqlmodel";
  #   rev = version;
  #   sha256 = "sha256-HASWDm64vZsOnK+cL2/G9xiTbsBD2RoILXrigZMQncQ=";
  # };
  src = pkgs.fetchFromGitHub {
    owner = "farahats9";
    repo = "sqlmodel";
    rev = "4ce8d0720e9d76069257e46c35b1219b8ab72142";
    hash = "sha256-flFrjwkxaqjttvuS5ezgwcbHamy7Qr2COf65Q/AM4Vw=";
  };

  pythonImportsCheck = [
    "sqlmodel"
  ];

  postPatch = ''
      sed -i -E \
        -e 's#,<=2.0.11##g' \
        -e 's#(version = )"0"#\1"${version}"#g' \
        ./pyproject.toml
    '';

  propagatedBuildInputs = [
    poetry-core
    pydantic
    sqlalchemy
  ];
  meta = with lib; { };
}
# =sqlmodel= package:1 ends here
