// [[file:../arroyo-native-parser.org::*Library definition and exports][Library definition and exports:1]]
use pyo3::prelude::*;

pub mod parse;
pub mod types;

#[pymodule]
fn arroyo_rs(py: Python, m: &PyModule) -> PyResult<()> {
    #[pyfn(m)]
    fn parse_file(path: String) -> PyResult<types::Document> {
        Ok(parse::parse_document(path)?)
    }

    m.add_class::<types::Document>()?;
    m.add_class::<types::Heading>()?;
    m.add_class::<types::Keyword>()?;
    m.add_class::<types::Link>()?;

    m.add("InvalidDocError", py.get_type::<types::InvalidDocError>())?;

    Ok(())
}
// Library definition and exports:1 ends here
