# [[file:../arroyo-native-parser.org::*Tests][Tests:2]]
import arroyo.arroyo_rs 
import arroyo.models

def test_assert_logic():
    doc = arroyo.arroyo_rs.parse_file("./arroyo-native-parser.org")

    assert doc.keywords[0].file == "./arroyo-native-parser.org"
    assert doc.keywords[0].keyword == "TITLE"
    assert doc.keywords[0].value == "The arroyo_rs Native Org Parser"

    assert doc.headings[0].id == "20231023T115950.248543"
    assert doc.headings[0].level == 0
    assert len(doc.headings[0].text) > 0
    assert len(doc.headings[0].links) > 0
    assert len(doc.headings[0].aliases) == 2
    assert doc.headings[0].refs[0] == "https://code.rix.si/rrix/arroyo_rs"
    assert doc.headings[0].tags == ["Project"]
    assert doc.headings[-1].tags == ["Project", "Code"]

    assert doc.headings[0].links[0].from_file == "./arroyo-native-parser.org"
    assert doc.headings[0].links[0].from_id == "20231023T115950.248543"
    assert doc.headings[0].links[0].to == "id:1fb8fb45-fac5-4449-a347-d55118bb377e"
    assert doc.headings[0].links[0].to_proto == "id"
    assert doc.headings[0].links[0].text == "org-mode"

def test_relationships():
    assert arroyo.arroyo_rs.Heading is not None
    assert arroyo.arroyo_rs.Document is not None
    assert arroyo.arroyo_rs.Keyword is not None
    assert arroyo.arroyo_rs.Link is not None

def test_sqlmodel_conversion():
  native = arroyo.arroyo_rs.parse_file("./arroyo-native-parser.org")
  taglinks = arroyo.models.Tag.from_native_doc(native)
  headings = arroyo.models.Heading.from_native_doc(native)
  keywords = arroyo.models.Keyword.from_native_doc(native)
  document = arroyo.models.Document.from_native_doc(native)

  assert(len(keywords) == 5)
  assert(headings[0].node_id == '20231023T115950.248543')
  assert(headings[1].node_id == None)
  assert(headings[1].text == "Overview")
# Tests:2 ends here
